//
//	nMail.dll wb_
//	  Copyright (c) 1999, 2000 Nanshiki corporation
//
//	  1999/ 9/ 1 Version 1.00
//	  2000/ 5/24 Version 1.08
//	  2000/11/ 1 Version 1.10
//	  2001/ 1/26 Version 1.14
//

#ifndef _NMAIL_H_
#define _NMAIL_H_

#ifndef _WINSOCKAPI_
#include <winsock.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define NMAIL_ATTACHMENT_TEMP_SIZE	400

#define	NMAIL_ERROR_SOCKET			(-1)	// ڑG[
#define	NMAIL_ERROR_AUTHENTICATE	(-2)	// F؎s
#define NMAIL_ERROR_INVALID_NO		(-3)	// [ԍȂ
#define NMAIL_ERROR_TIMEOUT			(-4)	// ^CAEg
#define NMAIL_ERROR_FILE_OPEN		(-5)	// Ytt@C̃I[vs
#define NMAIL_ERROR_PARTIAL			(-6)	// t@CSĂȂ
#define NMAIL_ERROR_FILE_ALREADY	(-7)	// Ytt@Cłɑ݂
#define NMAIL_ERROR					(-10)	// ̑̃G[

#define NMAIL_ERROR_SERVICE_NOT_AVAILABLE		(-421)	// T[rXpł
#define NMAIL_ERROR_MAILBOX_UNAVAILABLE			(-450)	// [{bNXgps(gp)
#define NMAIL_ERROR_LOCAL_ERROR					(-451)	// T[o[G[
#define NMAIL_ERROR_INSUFFICIENT_SYSTEM_STORAGE	(-452)	// VXeeʕsG[
#define NMAIL_ERROR_SYNTAX_ERROR				(-500)	// R}h̕@G[
#define NMAIL_ERROR_PARAMETER					(-501)	// p[^̕@G[
#define NMAIL_ERROR_COMMAND_NOT_IMPLEMENTED		(-502)	// R}h
#define NMAIL_ERROR_BAD_SEQUENCE				(-503)	// R}h̃V[PXُ
#define NMAIL_ERROR_USER_UNKOWN					(-550)	// MȂ
#define NMAIL_ERROR_USER_NOT_LOCAL				(-551)	// [U[݂ȂA]斳
#define NMAIL_ERROR_EXCEEDED_STORAGE_ALLOCATION	(-552)	// eʃI[o[G[
#define NMAIL_ERROR_MAILBOX_NAME_NOT_ALLOWED	(-553)	// [{bNXȂ
#define NMAIL_ERROR_RELAY_OPERATION_REJECTED	(-553)	// [h~G[
#define NMAIL_ERROR_TRANSACTION_FAILED			(-554)	// gUNVs

#define NMAIL_NO_ATTACHMENT_FILE	(-1)	// Ytt@CȂ
#define NMAIL_ATTACHMENT_FILE		(0)		// Ytt@C(ĂȂ)

#define NMAIL_SUCCESS				(1)		// I

#define NMAIL_ADD_DATE_FIELD		(1)		// wb_DatetB[ht
#define NMAIL_ADD_MESSAGEID_FIELD	(2)		// wb_Message-IDtB[ht

#define NMAIL_OPTION_TIMEOUT			(0)		// ^CAEg
#define NMAIL_OPTION_HEADER_MAX			(1)		// wb_ől
#define NMAIL_OPTION_BODY_MAX			(2)		// {ől
#define NMAIL_OPTION_ALREADY_FILE		(3)		// t@C݂ꍇ̏
#define NMAIL_OPTION_DEBUG_MODE			(4)		// fobN[h

#define NMAIL_FILE_OVERWRITE		(0)		// t@C݂ꍇ㏑
#define NMAIL_FILE_RENAME			(1)		// t@C݂ꍇOύXĕۑ
#define NMAIL_FILE_ALREADY_ERROR	(2)		// t@C݂ꍇG[

#define NMAIL_GET_ERROR_MESSAGE		(0)		// G[bZ[W
#define NMAIL_GET_DEBUG_MESSAGE		(1)		// fobNbZ[W

#define NMAIL_DEBUG_START		(1)		// fobNJn
#define NMAIL_DEBUG_END			(0)		// fobNI

#define NMAIL_GET_UIDL_ALL		(0)		// SĂ UIDL 𓾂


//
//	o[W𓾂
//	in:  Ȃ
//	out: o[W (: 1.10 .. 110)
//
int WINAPI NMailGetVersion(VOID);

//
//	p[^ݒ
//	in:  TimeOutSec .. ^CAEg(bP)
//	     HeaderMax  .. wb_̍ől(oCg)
//	     BodyMax    .. [{̍ől(oCg)
//	out: Ȃ
//
VOID WINAPI NMailSetParameter(int TimeOutSec, int HeaderMax, int BodyMax);

//
//	WinSock 
//	in:  Ȃ
//	out: TRUE .. 
//
BOOL WINAPI NMailInitializeWinSock(VOID);

//
//	WinSock I
//	in:  Ȃ
//	out: TRUE .. I
//
BOOL WINAPI NMailEndWinSock(VOID);

//
//	POP3 T[oɐڑ
//	in:  HostName .. POP3 zXg
//	out: \Pbg
//	     INVALID_SOCKET ŃG[
//
SOCKET WINAPI NMailPop3Connect(LPCSTR HostName);

//
//	POP3 T[oɐڑ(|[gԍw)
//	in:  HostName .. POP3 zXg
//       PortNo   .. |[gԍ
//	out: \Pbg
//
SOCKET WINAPI NMailPop3ConnectPortNo(LPCSTR HostName, int PortNo);

//
//	POP3 F
//	in:  Socket   .. \Pbg
//	     Id       .. [U[
//	     Password .. pX[h
//	     APopFlag .. APOP gp邩(True Ŏgp)
//	out: [
//	     ̐ŃG[
//
int WINAPI NMailPop3Authenticate(SOCKET Socket, LPCSTR Id, LPCSTR Password, BOOL APopFlag);

//
//	POP3 ڑI
//	in:  Socket   .. \Pbg
//	out: ̐ŃG[
//
int WINAPI NMailPop3Close(SOCKET Socket);

//
//	POP3 [̏𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     SizeFlag .. TRUE ȂTCYԂ
//	out: SizeFlag  TRUE ȂTCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMailStatus(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, BOOL SizeFlag);

//
//	POP3 [̃TCY𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	out: [̃TCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMailSize(SOCKET Socket, int No);

//
//	POP3 [𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     Header   .. [̃wb_
//	     Body     .. [̖{
//	     Path     .. Ytt@CۑfBNg
//	                 NULL ŕۑ
//	     FileName .. Ytt@Ci[obt@
//	                 NULL Ŋi[
//	out: [̃TCY
//	     ̐ŃG[
//
int WINAPI NMailPop3GetMail(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName);

//
//	POP3 [𓾂(Ytt@CΉ)
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Subject  .. [̑薼
//	     Date     .. [̑M
//	     From     .. [̍ol
//	     Header   .. [̃wb_
//	     Body     .. [̖{
//	     Path     .. Ytt@CۑfBNg
//	     FileName .. Ytt@Ci[obt@
//	out: ̐ŃG[
//
int WINAPI NMailPop3GetMailPartial(SOCKET Socket, int No, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName);

//
//	POP3 [폜
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	out: ̐ŃG[
//
int WINAPI NMailPop3DeleteMail(SOCKET Socket, int No);

//
//	POP3 [Ytt@Ct`FbN
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Id       .. t@C ID i[obt@
//	     Max      .. obt@TCY
//	out: NMAIL_NO_ATTACHMENT_FILE    .. Ytt@CȂ
//	     NMAIL_ATTACHMENT_FILE ȏ  .. Ytt@C
//	                                    NMAIL_ATTACHMENT_FILE(0) ŕ
//	                                    ĂȂYtt@C
//	                                    1 ȏ̏ꍇĂYt
//	                                    t@CŐl̓p[gԍ
//
int WINAPI NMailPop3GetAttachmentFileStatus(SOCKET Socket, int No, LPSTR Id, int Max);

//
//	UIDL 𓾂
//	in:  Socket   .. \Pbg
//	     No       .. [ԍ
//	     Uidl     .. UIDL i[obt@
//	     Max      .. obt@TCY
//	out: ̐ŃG[
//
int WINAPI NMailPop3GetUidl(SOCKET Socket, int No, LPSTR Uidl, int Max);

//
//	[𑗐M
//	in:  HostName .. SMTP T[o
//	     To       .. 
//	     Cc       .. CC
//	     Bcc      .. BCC
//	     From     .. ol
//	     Subject  .. 薼
//	     Body     .. [{
//	     Header   .. ̃wb_
//	     Path     .. Ytt@C(ȂNULL)
//	     Flag     .. wb_Date/Message-IDt邩
//	out: ̐ŃG[
//
int WINAPI NMailSmtpSendMail(LPCSTR HostName, LPCSTR To, LPCSTR Cc, LPCSTR Bcc, LPCSTR From, LPCSTR Subject, LPCSTR Body, LPCSTR Header, LPCSTR Path, int Flag);

//
//	[𑗐M
//	in:  HostName .. SMTP T[o
//	     To       .. 
//	     Cc       .. CC
//	     Bcc      .. BCC
//	     From     .. ol
//	     Subject  .. 薼
//	     Body     .. [{
//	     Header   .. ̃wb_
//	     Path     .. Ytt@C(ȂNULL)
//	     Flag     .. wb_Date/Message-IDt邩
//	     PortNo   .. SMTP |[gԍ
//	out: ̐ŃG[
//
int WINAPI NMailSmtpSendMailPortNo(LPCSTR HostName, LPCSTR To, LPCSTR Cc, LPCSTR Bcc, LPCSTR From, LPCSTR Subject, LPCSTR Body, LPCSTR Header, LPCSTR Path, int Flag, int PortNo);

//
//	wb_i[Ăobt@珊̃tB[ho
//	in:  Field    .. tB[hli[obt@
//	     Header   .. wb_i[Ăobt@
//	     Name     .. tB[h
//	     Size     .. i[obt@̃TCY
//	out: TRUE     .. tB[h
//
BOOL WINAPI NMailGetHeaderField(LPSTR Field, LPCSTR Header, LPCSTR Name, int Size);

//
//	t@CJn
//	in:  Temp        .. ꎞƃGA
//	                    NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                    NULL  nMail.DLL ̃obt@gp
//	     Subject     .. [̑薼
//	     Date        .. [̑M
//	     From        .. [̍ol
//	     Header      .. WJ̃wb_i[obt@
//	     Body        .. WJ̖{i[obt@
//	     Path        .. Ytt@CۑfBNg
//	     FileName    .. Ytt@Ci[obt@
//	     FirstHeader .. ŏ̃[wb_
//	     FirstBody   .. ŏ̃[{
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileFirst(LPSTR Temp, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName, LPCSTR FirstHeader, LPCSTR FirstBody);

//
//	t@C
//	in:  Temp       .. ꎞƃGA
//	                   NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	                   NULL  nMail.DLL ̃obt@gp
//	     NextHeader .. Qڈȍ~̃[wb_
//	     NextBody   .. Qڈȍ~̃[{
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileNext(LPSTR Temp, LPCSTR NextHeader, LPCSTR NextBody);

//
//	t@C(VisualBasic p)
//
int WINAPI NMailAttachmentFileNextVB(LPSTR Temp, LPSTR Subject, LPSTR Date, LPSTR From, LPSTR Header, LPSTR Body, LPCSTR Path, LPSTR FileName, LPCSTR NextHeader, LPCSTR NextBody);

//
//	t@CI
//	in:  Temp     .. ꎞƃGA
//	                 NMAIL_ATTACHMENT_TEMP_SIZE mۂĂKv
//	out: ̐ŃG[
//
int WINAPI NMailAttachmentFileClose(LPSTR Temp);

//
//	t@C̏𓾂
//	in:  Header   .. wb_i[Ăobt@
//	     Id       .. t@C ID i[obt@
//	     Max      .. obt@TCY
//	out: NMAIL_NO_ATTACHMENT_FILE    .. Ytt@CȂ
//	     NMAIL_ATTACHMENT_FILE ȏ  .. Ytt@C
//	                                    NMAIL_ATTACHMENT_FILE(0) ŕ
//	                                    ĂȂYtt@C
//	                                    1 ȏ̏ꍇĂYt
//	                                    t@CŐl̓p[gԍ
//
int WINAPI NMailAttachmentFileStatus(LPCSTR Header, LPSTR Id, int Max);

//
//	IvVݒ
//	in:  Option  .. IvV
//	     Value   .. IvV̒l
//
BOOL WINAPI NMailSetOption(int Option, int Value);

//
//	IvVl̎擾
//	in:  Option  .. IvV
//  out: IvV̒l
//
int WINAPI NMailGetOption(int Option);

//
//	G[bZ[W𓾂
//	in:  Mtype    .. bZ[W
//		 Message  .. bZ[Wi[obt@
//	     Size     .. obt@TCY
//
VOID WINAPI NMailGetMessage(int Mtype, LPSTR Message, int Size);

#ifdef __cplusplus
}
#endif

#endif
